AbilityData = {
	AllAbilities = {
		-- Slot 1 Weapon Class Abilities
		Flurry = { 
			ApplicableClasses = { 
				Fist = true, 
				Vshort = true, 
				Short = true,
				Ranged = true,
			},
			CooldownTimer=20,
			AbilityTriggertype = {
					Instant = true,
					Triggered = false
			},
			MaxCharges = 0,
			Duration = 6,
			CompletionDelay = 1,
			StaminaCost = 17,
			combatAbilityScriptOnUser = "ca_flurry_script",
			TooltipString = "Type: Instant\nIncreases attack speed significantly for 3-5 attacks. The last attack is slowed greatly. During Flurry, damage is decreased by 7-35% for the fast attacks",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",	
			DependentUserCombatState = {
				Cloaked = false,
			},			
		},

		Followthrough = { 
			ApplicableClasses = { 
				ShortMid = true,
				Mid = true,
				MidLong = true,
			},
			AbilityTriggertype= {
				Instant = true,
				Triggered = false
			},
			CooldownTimer = 18,
			StaminaCost = 60,
			combatAbilityScriptOnUser = "ca_followthrough_script",
			MinDamModInst = 105,
			MaxDamModInst = 120,
			MinDamModTrig = 75,
			MaxDamModTrig = 90,
			nextSwingDelay= 1.2,
			TargetFX = "BloodEffect_A",		
			TooltipString = "Type: Instant\nPerform a quick swing followed by a heavy attack. (Resets Swing)",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			ManaCostDivisor = 2,
			ResetSwingTime = true,
			SwingAnimation = "followthrough",
			AbilityType = "InstantAttack",
		},	
		
		Wideswipe = { 
			Icon = "wideswept",
			DisplayName = "Wideswipe",
			AbilityType = "InstantAttack",
			AlwaysUsable = true,
			AbilityTriggertype= {
					Instant = true,
					Triggered = false,
			},
			ApplicableWepDamClasses = { 
				Slashing = true,
			},
			isTargetRequired = true,
			ResetSwingTime = true,
			CooldownTimer = 8,
			StaminaCost = 45,
			nextSwingDelay = 4,
			combatAbilityScriptOnUser = "ca_wideswipe_effect",
			FreezeDuration = 2000,
			AttackerFX = "BuffEffect_B",
			TargetFX = "BloodEffect_A",
			TooltipString = "Type: Instant\nSlice across your opponents in an area of effect in front of you, dealing damage to each of them.",
			AbilityEnabled = true,
			AssociatedSkill = "SlashingSkill",
			LevelRequired = 35,
			SwingAnimation = "wideswept_attack",
		},	

		Sunder = { 
			ApplicableClasses = { 
				Long = true,
				RangeMelee = true
			},
			AbilityType = "InstantAttack",
			AbilityTriggertype= {
				Instant = true
			},
			CooldownTimer = 10,
			MinDamModInst = 90,
			MaxDamModInst = 110,
			StaminaCost = 25,
			nextSwingDelay= .4,
			combatAbilityTriggerScriptTarget = "ca_sunder_target_effect",
			AttackerFX = "BuffEffect_B",
			TargetFX = "BloodEffect_A",
			TargetSFX = "Sunder",
			TooltipString = "Type: Instant\nA special attack will that deals slightly reduced damage 10-30% and applies \"Sundered Armor\" to the target, increasing penetration of attacks the target receives. (Resets Swing)",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			ResetSwingTime = true,
			SwingAnimation = "sunder",
		},	

		Forcestab = { 
			DisplayName = "Force Stab",
			AbilityType = "InstantAttack",			
			AlwaysUsable = true,
			AbilityTriggertype= {
				Instant = true
			},
			ApplicableWepDamClasses = { 
				Slashing = true,
				Piercing = true,
			},
			CooldownTimer = 10,
			isTargetRequired = true,
			CooldownTimer = 3,
			StaminaCost = 55,
			nextSwingDelay= .7,
			combatAbilityScriptOnUser = "ca_forcestab_effect",
			TooltipString = "Type: Instant\nStab your enemy with all your might, knocking them back.",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			LevelRequired = 30,
			SwingAnimation = "impale",
		},	
		-- Slot 2 (W) --Damage Type Abilities
		Pulverize = { 
			ApplicableWepDamClasses = { 
				Bashing = true
			},
			AbilityTriggertype= {
				Triggered = true
			},
			CooldownTimer = 5,
			MinDamModTrig = 120,
			MaxDamModTrig = 135,
			StaminaCost = 30,
			nextSwingDelay= .5,
			AttackerFX = "BuffEffect_B",
			TargetFX = "BloodEffect_A",
			TooltipString = "Type: Triggered\nA powerful blow dealing 20-35% bonus damage to the target.",
			AbilityEnabled = true,
			AssociatedSkill = "BashingSkill",
			LevelRequired = 15,
			SwingAnimation = "pummel",
		},			

		Rend = { 
			ApplicableWepDamClasses = { 
				Slashing = true,
			},
			AbilityTriggertype= {
				Triggered = true
			},
			CooldownTimer = 0,
			MinDamModTrig = 100,
			MaxDamModTrig = 110,
			StaminaCost = 30,
			nextSwingDelay= .4,
			combatAbilityTriggerScriptTarget = "ca_rend_target_effect",
			AttackerFX = "BuffEffect_B",
			TargetFX = "BloodEffect_A",			
			AttackerIdObjvar = "RendInflicter",
			TooltipString = "Type: Triggered\n Viciously wrenches your blade after striking your target causing the wound to bleed for a short time and all healing to be reduced by 50%.",
			AbilityEnabled = true,
			AssociatedSkill = "SlashingSkill",
			LevelRequired = 15,
			SwingAnimation = "rend",
		},	

		Impale = { 
			ApplicableWepDamClasses = { 
				Piercing = true,
			},
			AbilityTriggertype= {
				Triggered = true
			},
			CombatAbilityCritChanceModifier = 1.4,
			CooldownTimer = 5,
			MinDamModTrig = 110,
			MaxDamModTrig = 135,
			StaminaCost = 25,
			nextSwingDelay= 1,
			combatAbilityTriggerScriptTarget = "ca_impale_target_effect",
			AttackerFX = "BuffEffect_B",
			TargetFX = "SlowEffect",
			TooltipString = "Type: Triggered\nA strong attack driving your weapon into your opponent, causing their next attacks to be slower and deal less damage.",
			AbilityEnabled = true,
			AssociatedSkill = "PiercingSkill",
			LevelRequired = 15,
			SwingAnimation = "impale",
		},	

		-- Slot 3 (E) --Counter Abilities	
		Crosscut = {
			DisplayName = "Cross Cut",
			ApplicableWepDamClasses = { 
				Slashing = true,
			},
			AbilityType = "InstantAttack",
			AbilityTriggertype={
				Instant = true
			},
			CooldownTimer = 1,
			isTargetRequired = true,
			MinDamModInst = 110,
			MaxDamModInst = 125,
			StaminaCost = 15,
			nextSwingDelay= .4,
			combatAbilityScriptOnUser = "ca_crosscut_script",
			TargetFX = "SunderEffect",
			TooltipString = "Type: Instant\n A counter attack executed by performing a sidestep and slicing cut at opponent.",
			AbilityEnabled = true,
			AssociatedSkill = "SlashingSkill",
			LevelRequired = 15,
			DependentUserCombatState = {
				Countering = true
			},
		},

		Riposte = {
			ApplicableWepDamClasses = { 
				Piercing = true,
			},
			AbilityType = "InstantAttack",
			AbilityTriggertype={
				Instant = true
			},
			MinDamModInst = 100,
			MaxDamModInst = 110,
			CooldownTimer = 1,
			isTargetRequired = true,
			CombatAbilityCritChanceModifier = 3,
			StaminaCost = 15,
			nextSwingDelay= .2,
			TargetFX = "BloodEffect_A",
			TooltipString = "Type: Instant\n A counter attack execued by a quick thrust through an opponent's guard.",
			AbilityEnabled = true,
			AssociatedSkill = "PiercingSkill",
			LevelRequired = 15,
			SwingAnimation = "lunge",
			DependentUserCombatState = {
				Countering = true
			},

		},

		DrivingStrike = {
			DisplayName = "Driving Strike",
			ApplicableWepDamClasses = { 
				Bashing = true,
			},
			AbilityType = "InstantAttack",
			AbilityTriggertype={
				Instant = true
			},
			CooldownTimer = 1,
			isTargetRequired = true,
			CombatAbilityCritChanceModifier = 1.2,
			MinDamModInst = 105,
			MaxDamModInst = 120,
			StaminaCost = 20,
			nextSwingDelay= .2,
			combatAbilityScriptOnTarget = "ca_drivingstrike_effect",
			combatAbilityTriggerScriptUser = "ca_drivingstrike_user",
			TargetFX = "BloodEffect_A",
			TooltipString = "Type: Instant\n A counter attack executed by a stepping into an opponent's strike and delivering a quick strike to knock them back.",
			AbilityEnabled = false,
			AssociatedSkill = "BashingSkill",
			LevelRequired = 15,
			DependentUserCombatState = {
				Countering = true
			},
		},

		Pommel = {
			ApplicableClasses = { 
				Mid = true,
				MidLong = true,
				Long = true,
				RangeMelee = true,
				Shield = false
			},

			--DFB TODO: Implement restricted classes.
			RestrictedClasses = {
				Shield = true
			},
			AbilityType = "InstantAttack",
			AbilityTriggertype={
				Instant = true
			},
			CooldownTimer = 0,
			MinDamModInst = 30,
			MaxDamModInst = 60,
			StaminaCost = 5,
			DependentUserCombatState = {
				Countering = true
			},
			CanMiss = false,
			nextSwingDelay= .2,
			isTargetRequired = true,
			OverrideDamageClass = "Bashing",
			TargetFX = "BloodEffect_A",
			AttackerFX = "BuffEffect_B",
			TooltipString = "Type: Instant\nRequirement: Recently Dodged or Parried\nAttempts to strike the target with the handle of the current weapon dealing 30-50% damage after a successful parry or dodge.",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			LevelRequired = 10,
			SwingAnimation = "pommel",
			DependentStance = {
				Aggressive = true,
			},
		},

		Shield_Bash = {
			DisplayName = "Shield Bash",
			ApplicableClasses = { 
				Shield = true,
			},
			AbilityType = "InstantAttack",
			AbilityTriggertype={
				Instant = true
			},
			CooldownTimer = 3,
			MinDamModInst = 80,
			MaxDamModInst = 180,
			StaminaCost = 10,
			DependentUserCombatState = {
				Blocking = true,
			},
			CanMiss = false,
			nextSwingDelay= .2,
			isTargetRequired = true,
			OverrideDamageClass = "Bashing",
			TargetFX = "ShieldBashEffect",
			TargetSFX = "ShieldBash",
			TooltipString = "Type: Instant\nRequirement: Blocking\nSlam your shield into your opponent while in the blocking state, dealing 70-120% of shield damage and	staggering the target.",
			AbilityEnabled = true,
			AssociatedSkill = "BlockingSkill",
			LevelRequired = 10,
			SwingAnimation = "shield_bash",
		},
				

	-- Slot 4 ( R ) -- Stance Abilities
		Charge = {
			DisplayName = "Charge",
			ApplicableClasses = {
				Melee = true
			},
			AbilityTriggertype={
				Instant = true,
			},
			MinDamModInst = 120,
			MaxDamModInst = 130,
			CombatAbilityCritChanceModifier = 1.1,
			CooldownTimer = 30,
			Duration = 6,
			CompletionDelay = 1,
			combatAbilityScriptOnUser = "ca_charge_script",
			combatAbilityTriggerScriptTarget = "ca_charge_target_effect",
			ResetSwingTime = true,
			StaminaCost = 40,
			DependentStance = {
				Aggressive = true,
			},
			TooltipString = "Type: Instant\nCharge toward target at increased speed, increasing damage for next attack by 20-40% , crit chance by 10% and stunning the target for 1 second. (Resets Swing)",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			LevelRequired = 25,
			ManaCostDivisor = 2,
			AbilityType = "InstantAttack",

		},		

		--[[Spinattack = {
			DisplayName = "Spin Attack",
			ApplicableWepDamClasses = { 
				Slashing = true,
			},
			AbilityTriggertype={
				Instant = true,
			},
			CooldownTimer = 12,
			Duration = 6,
			CompletionDelay = 1,
			combatAbilityScriptOnUser = "ca_spinattack_script",
			ResetSwingTime = true,
			isTargetRequired = false,
			StaminaCost = 45,
			TooltipString = "Type: Instant\nSpin around yourself, dealing damage to everything around you",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			LevelRequired = 35,
			ManaCostDivisor = 2,
			AbilityType = "InstantAttack",
			SwingAnimation = "sword_in_ground",

		},	]]--	

		Shockwave = {
			DisplayName = "Shockwave",
			ApplicableClasses = {
				Melee = true
			},
			AbilityTriggertype={
				Instant = true,
			},
			CooldownTimer = 15,
			Duration = 6,
			CompletionDelay = 1,
			combatAbilityScriptOnUser = "ca_shockwave_script",
			ResetSwingTime = true,
			isTargetRequired = false,
			StaminaCost = 55,
			DependentStance = {
				Aggressive = true,
			},
			TooltipString = "Type: Instant\nThrow your weapon into the ground with unbelievable force, pushing everything near you away and dealing damage (Resets Swing)",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			LevelRequired = 35,
			ManaCostDivisor = 2,
			AbilityType = "InstantAttack",
			SwingAnimation = "sword_in_ground",

		},		

		Lunge = {
			ApplicableClasses = { 
				Melee = true
			},
			AbilityType = "InstantAttack",
			AbilityTriggertype={
				Instant = true
			},
			CooldownTimer = 5,
			MinDamModInst = 60,
			MaxDamModInst = 75,
			RangeModifier = 3,
			StaminaCost = 25,
			DependentStance = {
				Passive = true,
			},
			combatAbilityScriptOnUser ="ca_lunge_script",
			combatAbilityTriggerScriptTarget = "ca_lunge_target_effect",
			ResetSwingTime = true,
			isTargetRequired = true,
			TargetFX = "BloodEffect_A",
			TooltipString = "Type: Instant\nAn attack that stretches to reach target, temporarily increasing attack range for one attack. This attack has damage reduced by 25-50%. (Resets Swing)",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			LevelRequired = 5,
			ManaCostDivisor = 2,
			SwingAnimation = "lunge",
		},

		Taunt = {
			ApplicableClasses = { 
				Melee = true
			},
			AbilityTriggertype={
				Instant = true
			},
			AbilityType = "InstantAttack",
			CooldownTimer = 3,
			StaminaCost = 0,
			DependentStance = {
				Defensive = true,
			},
			combatAbilityScriptOnUser = "ca_taunt_target_effect",
			ResetSwingTime = false,
			isTargetRequired = true,
			TooltipString = "Type: Instant\nTaunt your opponent, attempting to cause him to focus on you.",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			LevelRequired = 5,
			ManaCostDivisor = 2,
			SwingAnimation = "ShowingOff",
		},

		Defend = {
			ApplicableClasses = {
				Melee = true
			},
			AbilityTriggertype={
				Instant = true,
			},
			CombatAbilityCritChanceModifier = .7,
			CooldownTimer = 20,
			Duration = 5,
			CompletionDelay = 1,
			combatAbilityScriptOnUser = "ca_defend_script",
			ResetSwingTime = false,
			StaminaCost = 15,
			DependentUserCombatState = {
				Defending = false,
				Blocking = false,
				Countering = false,
			},
			DependentStance = {
				Defensive = true,
			},
			TooltipString = "Type: Instant\nIncreases success and effectiveness of defensive abilities, such as parry, block and dodge.",
			AbilityEnabled = true,
			AssociatedSkill = "MeleeSkill",
			LevelRequired = 0,
		},

		Backstab = {
			ApplicableClasses = { 
				Fist = true,
				Vshort = true, 
				Short = true,
			},
			AbilityTriggertype={
				Instant = true
			},
			AbilityType = "InstantAttack",
			CooldownTimer = 5,
			MinDamModInst = 200,
			MaxDamModInst = 350,
			RangeModifier = 3,
			StaminaCost = 10,
			combatAbilityScriptOnUser ="sca_backstab",
			combatAbilityTriggerScriptTarget = "sca_backstab_effect",
			CombatAbilityCritChanceModifier = 10,
			ResetSwingTime = true,
			isTargetRequired = false,
			CanMiss = false,
			TargetFX = "BloodEffect_A",
			TooltipString = "Type: Instant\nWhile cloaked, quickly step behind your target and stab them in the back.",
			AbilityEnabled = true,
			AssociatedSkill = "RogueSkill",
			LevelRequired = 10,
			ManaCostDivisor = 2,
			SwingAnimation = "impale",
			OverrideDamageClass = "TrueDamage",
			SkillRequirement = {
					RogueSkill = 10,
				},	
			DependentUserCombatState = {
				Cloaked = true,
			},	
		},

		Perforate = { 
			Icon='barrage',
			ApplicableWepDamClasses = { 
				Piercing = true,
			},
			CooldownTimer=35,
			AbilityTriggertype = {
				Instant = true,
				Triggered = false
			},
			MaxCharges = 0,
			Duration = 3,
			CompletionDelay = 1,
			StaminaCost = 50,
			combatAbilityScriptOnUser = "ca_perforate_user_effect",
			TooltipString = "Type: Instant\nIncreases attack speed slightly 2-7 seconds decreases attack speed slightly for 5 seconds after. Crit Chance is set to 100%",
			AbilityEnabled = true,
			AssociatedSkill = "PiercingSkill",	
			LevelRequired = 25,
			DependentUserCombatState = {
				Cloaked = false,
			},			
		},

		Puncture = { 
			ApplicableClasses = { 
				Fist = true, 
				Vshort = true, 
				Short = true,
			},
			ApplicableWepDamClasses = { 
				Piercing = true,
			},
			AbilityTriggertype= {
				Triggered = true
			},
			CombatAbilityCritChanceModifier = 3,
			CooldownTimer = 10,
			MinDamModTrig = 120,
			MaxDamModTrig = 150,
			StaminaCost = 45,
			nextSwingDelay= 1,
			AttackerFX = "BuffEffect_B",
			TargetFX = "BloodEffect_A",
			TooltipString = "Type: Triggered\nA strong attack targeting the weak points in the opponents armor. ",
			AbilityEnabled = true,
			AssociatedSkill = "PiercingSkill",
			LevelRequired = 20,
			SwingAnimation = "impale",
			BonusPenetration = 5,
		},	

	Eviscerate = { 
			ApplicableWepDamClasses = { 
				Slashing = true,
			},
			CooldownTimer=35,
			AbilityTriggertype = {
					Instant = true,
					Triggered = false
			},
			MaxCharges = 0,
			Duration = 5,
			CompletionDelay = 1,
			StaminaCost = 50,
			combatAbilityScriptOnUser = "ca_eviscerate_user_effect",
			TooltipString = "Type: Instant\nIncreases damage of next attack slightly, and increases crit chance to 100%. Bleed damage is doubled.",
			AbilityEnabled = true,
			AssociatedSkill = "SlashingSkill",	
			LevelRequired = 25,
		},	

		Evasion = { 
			ApplicableClasses = {
				Melee = true,
			},
			CooldownTimer=35,
			AbilityTriggertype = {
					Instant = true,
					Triggered = false
			},
			MaxCharges = 0,
			Duration = 3,
			CompletionDelay = 1,
			StaminaCost = 35,
			combatAbilityScriptOnUser = "ca_evasion_user_effect",
			TooltipString = "Type: Instant\nDoubles dodge chance for 2-7 seconds then reduces stamina regeneration by 50% for 5 seconds.",
			AbilityEnabled = true,
			AssociatedSkill = "DodgeSkill",	
			LevelRequired = 20,
			DependentUserCombatState = {
				Cloaked = false,
			},			
		},

ShadowStalk = {
			--Class = "Rogue",
			--Level = 20,
			Icon = "backstab",
			ApplicableClasses = { 
				Vshort = true
			},
			AbilityTriggertype={
				Instant = true
			},
			CooldownTimer = 5,
			--MinDamModInst = 200,
			--MaxDamModInst = 350,
			--RangeModifier = 3,
			--StaminaCost = 35,
			combatAbilityScriptOnUser ="Ab_Rog_ShadowStalk",
			--combatAbilityTriggerScriptTarget = "sca_backstab_effect",
			--CombatAbilityCritChanceModifier = 10,
			ResetSwingTime = true,
			isTargetRequired = false,
			CanMiss = false,
			--TargetFX = "BloodEffect_A",
			TooltipString = "Type: Instant\nWhile hidden, step through the shadows and deliver a devistating blow.",
			AbilityEnabled = true,
			--AssociatedSkill = "StealthSkill",
			--LevelRequired = 10,
			--ManaCostDivisor = 2,
			SwingAnimation = "impale",
			SkillRequirement = {
					--StealthSkill = 10,
				},	
			DependentUserCombatState = {
				Cloaked = true,
			},	
		},

		Sprint = {
			AlwaysUsable = true,
			AbilityTriggertype={
				Instant = true
			},
			StaminaCost = 0,
			combatAbilityScriptOnUser = "ca_sprint_script",
			TooltipString = "Type: Instant\nIncreases your run speed at the expense of your stamina.",
			IsPeacefulAbility = true,
			AbilityEnabled = true,
		}
	}
}