-- Editor main

toolbarItems = {}

-- Adds a tool to a bar. Name is internal name, display is displayed to user and init function is called on click
function AddToolbarItem(name,display,init)
	local item = {}
	item.name = name
	item.display = display
	item.init = init
	toolbarItems[name] = item
end

-- All tool requires should be placed here
require "editor.npcs"

-- Main editor init
function InitEditor()
	local toolbar = BuildToolbarWindow(toolbarItems)
	this:OpenDynamicWindow(toolbar)
end

-- Builds the toolbar window
function BuildToolbarWindow(toolbarItems)
	local NumItems = TableLength(toolbarItems)
	local ButtonWidth = 185

	local window = DynamicWindow("EditorToolbar", "Editor", NumItems*ButtonWidth+41, 10, 200, 200, "SemiTransparent")

	local itemCount = 0
	
	for name,item in pairs(toolbarItems) do
		local responseName = "EditorToolbar_"..name
		local serverCommand = "EditorToolbarClick "..name
		--DebugMessage("item.name is "..name)
		window:AddButton(itemCount * ButtonWidth+11, 0, responseName, item.display, ButtonWidth, 73, "", serverCommand, false, "TabButton")
		itemCount = itemCount + 1
	end

	return window
end

RegisterEventHandler(EventType.ClientUserCommand, "EditorToolbarClick", function (itemName)
	--DebugMessage("EditorToolbarClick: "..itemName)
	--DebugMessage(DebugTable(toolbarItems))
	toolbarItems[itemName].init()
end)

RegisterEventHandler(EventType.Message, "ShowEditor", function ()
		InitEditor()
	end)