-- Poison for items (bensku)

require "incl_effect_utils"
require "incl_effect_presets"

DEFAULT_APPLYING_TYPE = "food"
DEFAULT_DURATION = 10000

this:ScheduleTimerDelay(TimeSpan.FromSeconds(1) , "InitStatusEffectsTimer")

function InitStatusEffects()
	if initializer ~= nil then
		this:SetObjVar("ApplyingMethod", initializer.Type or DEFAULT_APPLYING_TYPE)
	end

	if initializer ~= nil and initializer.Effects ~= nil then
		--DebugMessage("initializer present")
		local effectData = {}

		for number,effect in ipairs(initializer.Effects) do
			--DebugMessage("for loop, "..number)
			if effect.Data ~= nil then
				--DebugMessage("effect data present")
				effectData[number] = effect.Data
			elseif effect.Preset ~= nil then
				effectData[number] = GetEffectPreset(effect.Preset)
			end

			if effect.duration ~= nil then -- Duration override possibility
				effectData[number].duration = effect.duration
			end
		end

		--DebugMessage("effectData size is "..#effectData)

		this:SetObjVar("EffectData", effectData)
	elseif initializer ~= nil and initializer.CureEffects ~= nil then
		--DebugMessage("CureEffects!")
		this:SetObjVar("CureEffects", initializer.CureEffects)
	end
end

function WriteEffectData(effects)
	local effectData = {}

	for number,effect in ipairs(effects) do
		if effect.Data ~= nil then
			effectData[number] = effect.Data
		elseif effect.Preset ~= nil then
			effectData[number] = GetEffectPreset(effect.Preset)
		end

		if effect.duration ~= nil then -- Duration override possibility
			effectData[number].duration = effect.duration
		end
	end

	this:SetObjVar("EffectData", effectData)
end

RegisterEventHandler(EventType.Timer, "InitStatusEffectsTimer", InitStatusEffects)

function ApplyUseEffect(user)
	local applyMethod = this:GetObjVar("ApplyingMethod")

	if applyMethod == "use" then
		local cure = this:GetObjVar("CureEffects")
		if cure ~= nil then
			for effect,uses in pairs(cure) do
				--DebugMessage("Cure effect "..effect.." "..uses.." times.")
				user:SendMessage("AddCureProcess", effect, uses)
			end
		end

		InitEffects(user)
		InflictFromPackedData(user, this:GetObjVar("EffectData"))
		user:SendMessage("WakeUpEffects")
	end
end

RegisterEventHandler(EventType.Message, "UseObject", ApplyUseEffect)
RegisterEventHandler(EventType.Message, "WriteEffectData", WriteEffectData)