------------------------------------------------------------
-- play a sound on yourself by typing /play soundname. Max 10 seconds
playsound=function(...)
	local args=table.pack(...)
	DebugMessage(tostring(args[1]))

	this:PlayObjectSound(args[1],false,10)
end

RegisterCommand{ Command="play", AccessLevel = AccessLevel.Immortal, Func=playsound, Usage="/play (soundname)", Desc="Plays a sound"}


------------------------------------------------------------

require 'soundlist'


function soundwindow()
	UI_SoundWindow(this)
end

function UI_SoundWindow(user)
		
		-- check if we have sound from [require 'soundlist.lua'] above
		if (soundlist==nil) then
			user:Systemmessage("No playable sounds found (soundlist=nil)")
		end
		

		local columns=6
		local ColWidth=200
		local RowHeight=25
		local x= 1
		local y= 1
		--Define the window 
		local newWindow = DynamicWindow("SoundWindow","Play a sound on selected target or location",columns*ColWidth,480)

		local i= 1
		--table.sort(soundlist)
		for k,sound in pairs(soundlist) do
			newWindow:AddButton(	x+(	(i-1)%columns)*ColWidth	, 
									y+(	math.floor(i/columns) * RowHeight ), 
									sound, 
									sound,  
									ColWidth, 
									RowHeight, 
									"Play the sound "..sound,
									"",
									false)
			i=i+1
		end

		this:OpenDynamicWindow(newWindow)
		end

RegisterCommand{ Command="soundwindow", AccessLevel = AccessLevel.Immortal, Func=UI_SoundWindow, Desc="A window with a list of playable sounds"}


---Handle the playound responses
RegisterEventHandler(EventType.DynamicWindowResponse, "SoundWindow",
  function (user,buttonId)
  	this:PlayObjectSound(buttonId,false, 10)
  end)